#pragma once
#include <FFGLSDK.h>
#include "GLResources.h"

class Particles : public Plugin
{
public:
	Particles();

	//CFreeFrameGLPlugin
	ffgl::FFResult InitGL( const ffgl::ViewportStruct* vp ) override;
	ffgl::FFResult DeInitGL() override;
	ffgl::FFResult ProcessOpenGL( ffgl::ProcessOpenGLStruct* pGL ) override;

protected:
	void UpdateParticles( float deltaTime );
	void RenderParticles();

	GLResources glResources;     //!< The container of our OpenGL resources.

	//Parameters
	ParamRange* fadeoutStart;
	ParamRange* smokeStart;
	ParamRange* smokeIntensity;
	ParamRange* energyMaxAgeFactor;
	ParamRange* turbulenceDetail;		//!< In range between 0.5 .. 1.5
	ParamRange* turbulenceSpeed;		//!< In range between 0.1 .. 2.0
	ParamOption* maxAge;
	ParamRange* particleSize;			//!< In range between 1.0 .. 10.0
	ParamRange* velocityToSizeFactor;	//!< In range between 1.0 .. 20.0
	ParamRange* numBuckets;				//!< In range between 16 .. MAX_BUCKETS
	ParamRange* numParticlesPerBucket;	//!< In range between 0 .. MAX_PARTICLES_PER_BUCKET
	ParamRange* burstDuration;
	ParamRange* burstIntensity;			//!< In range between 1.0 .. 16.0
	ParamBool* simulate;
	ParamFFT* fft;
};
